% Requires SacLab: rsac.m, lh.m

%winlen = 128; %Half the total window 
%samp = 1;
%fs = 1/samp;
% Multi-taper parameters
nw = 3;
%nfft = 512;

bf1 = 0.0; bf2 = 0.1;

% Frequency band (Hz)
f1 = 0.01;
f2 = 0.04;

sac = rsac('rec.sac'); rec = sac(:,2); t = sac(:,1);

% Get data and header info from SAC files that have been prepared by getscs.mac
noisesac = rsac('noise.sac'); nnpts = lh(noisesac,'NPTS'); noise = noisesac(1:nnpts,2); tnoise = noisesac(1:nnpts,1);
scs1sac = rsac('scs1.sac'); s1npts = lh(scs1sac,'NPTS'); scs1 = scs1sac(1:s1npts,2); tscs1 = scs1sac(1:s1npts,1);
scs2sac = rsac('scs2.sac'); s2npts = lh(scs2sac,'NPTS'); scs2 = scs2sac(1:s2npts,2); tscs2 = scs2sac(1:s2npts,1);
scs3sac = rsac('scs3.sac'); s3npts = lh(scs3sac,'NPTS'); scs3 = scs3sac(1:s3npts,2); tscs3 = scs3sac(1:s3npts,1);

%corr12sac = rsac('corr12.sac'); c12npts = lh(corr12sac,'NPTS'); corr12 = corr12sac(1:c12npts,2); tcorr12 = corr12sac(1:c12npts,1);
%corr23sac = rsac('corr23.sac'); c23npts = lh(corr23sac,'NPTS'); corr23 = corr23sac(1:c23npts,2); tcorr23 = corr23sac(1:c23npts,1);
%corr13sac = rsac('corr13.sac'); c13npts = lh(corr13sac,'NPTS'); corr13 = corr13sac(1:c13npts,2); tcorr13 = corr13sac(1:c13npts,1);

% Define parameters
nyq = 1/(2*lh(sac,'DELTA')); % Nyquist
fs = 1/(lh(sac,'DELTA')); % Sample frequency
npts = lh(sac,'NPTS'); % Number of points

%ptscs1 = lh(sac,'T0'); otscs1 = lh(sac,'T3');
%ptscs2 = lh(sac,'T1'); otscs2 = lh(sac,'T4');
%ptscs3 = lh(sac,'T2'); otscs3 = lh(sac,'T5');

%diff21 = lh(corr12sac,'T8') - lh(corr12sac,'T9')
%diff32 = lh(corr23sac,'T8') - lh(corr23sac,'T9')
%diff31 = lh(corr13sac,'T8') - lh(corr13sac,'T9')

%dt21 = lh(corr12sac,'T9')
%dt32 = lh(corr23sac,'T9')
%dt31 = lh(corr13sac,'T9')
%diff = lh(corrdiffsac,'T9');

% Detrend time-series
dnoise = detrend(noise);
dscs1 = detrend(scs1);
dscs2 = detrend(scs2);
dscs3 = detrend(scs3);

% Calculate spectrum
% [Pxx,f] = pmtm(x,nw,nfft,fs)
[Pnoise,fnoise] = pmtm(dnoise,nw,nnpts,fs,'eigen');
[Pscs1,fscs1] = pmtm(dscs1,nw,s1npts,fs,'eigen');
[Pscs2,fscs2] = pmtm(dscs2,nw,s2npts,fs,'eigen');
[Pscs3,fscs3] = pmtm(dscs3,nw,s3npts,fs,'eigen');

% Bandpass
%[b,a] = butter(2,[f1/nyq f2/nyq]);
%win = tukeywin(length(rec),0.25); recfilt = filtfilt(b,a,win.*(detrend(rec)));

%recfiltsac = [t recfilt sac(:,3)];

%scs1filtsac = cut(bpsac,otscs1-winlen,otscs1+winlen); scs1filt = scs1filtsac(1:lh(scs1filtsac,'NPTS'),2); tscs1filt = scs1filtsac(1:lh(scs1filtsac,'NPTS'),1);
%scs2filtsac = cut(bpsac,otscs2-winlen,otscs2+winlen); scs2filt = scs2filtsac(1:lh(scs2filtsac,'NPTS'),2); tscs2filt = scs2filtsac(1:lh(scs2filtsac,'NPTS'),1);
%scs3filtsac = cut(bpsac,otscs3-winlen,otscs3+winlen); scs3filt = scs3filtsac(1:lh(scs3filtsac,'NPTS'),2); tscs3filt = scs3filtsac(1:lh(scs3filtsac,'NPTS'),1);

%
%scs2filt = scs2filtsac(:,2);
%scs3filt = scs3filtsac(:,2);

% Cross-correlate

%win1 = tukeywin(length(scs1),0.25); scs1filt = filtfilt(b,a,win1.*(detrend(scs1)));
%win2 = tukeywin(length(scs2),0.25); scs2filt = filter(b,a,win2.*(detrend(scs2)));
%win3 = tukeywin(length(scs3),0.25); scs3filt = filter(b,a,win3.*(detrend(scs3)));

% Spectral ratio
fftlen = 2*(length(Pscs1)-1);
scs1amp = sqrt(((1/fs)*(2*(length(Pscs1)-1))*Pscs1));
scs2amp = sqrt(((1/fs)*(2*(length(Pscs2)-1))*Pscs2));
scs3amp = sqrt(((1/fs)*(2*(length(Pscs3)-1))*Pscs3));
        
ratio21 = log(scs2amp./scs1amp);
ratio32 = log(scs3amp./scs2amp);
ratio31 = log(scs3amp./scs1amp);

marat = 0;
if marat > 0
  a = 1;
  b = linspace(1/marat,1/marat,marat);
  ratio21 = filtfilt(b,a,ratio21);
  ratio32 = filtfilt(b,a,ratio32);
  ratio31 = filtfilt(b,a,ratio31);
end

% Transfer function estimate
% [Txy,F] = tfestimate(x,y,window,noverlap,nfft,fs)
%[Tran12,Ftran12] = tfestimate(scs1,scs2,[],[],[],1);
%[Tran23,Ftran23] = tfestimate(scs2,scs3,[],[],[],1);
%[Tran13,Ftran13] = tfestimate(scs1,scs3,[],[],[],1);

% Coherence estimate for weight
% [Cxy,F] = mscohere(x,y,window,noverlap,nfft,fs)
[Coh12,Fcoh12] = mscohere(dscs1,dscs2,[],[],s1npts,fs);
[Coh23,Fcoh23] = mscohere(dscs2,dscs3,[],[],s2npts,fs);
[Coh13,Fcoh13] = mscohere(dscs1,dscs3,[],[],s3npts,fs);

%funi = find((Ftran12 > 0.01) & (Ftran12 < 0.05) & (Coh12 > 0.8));
%freq = Ftran12(funi);
%Tran12n = Tran12(funi); Coh12n = Coh12(funi);
%Tran23n = Tran23(funi); Coh23n = Coh23(funi);
%Tran13n = Tran13(funi); Coh13n = Coh13(funi);

% Make measurements only in the band of interest
mini = find(fscs1 > f1);
maxi = find(fscs1 < f2);
inii = mini(1);
fini = maxi(max(maxi));

freq = fscs1(inii:fini);

% Spectral ratio
ratio21n = ratio21(inii:fini);
ratio32n = ratio32(inii:fini);
ratio31n = ratio31(inii:fini);

% Coherence
Coh12n = Coh12(inii:fini);
Coh23n = Coh23(inii:fini);
Coh13n = Coh13(inii:fini);

%[p21,S] = polyfit(freq,ratio21n,1);
%[p32,S] = polyfit(freq,ratio32n,1);
%[p31,S] = polyfit(freq,ratio31n,1);

% Least-squares inversion
[m12 mse12] = lscov([ones(length(freq),1) freq],ratio21n,Coh12n);
[m23 mse23] = lscov([ones(length(freq),1) freq],ratio32n,Coh23n);
[m13 mse13] = lscov([ones(length(freq),1) freq],ratio31n,Coh13n);

% t* calculation
dtstar21 = m12(2)/-pi; dtstar21se = mse12(2)/pi;
dtstar32 = m23(2)/-pi; dtstar32se = mse23(2)/pi;
dtstar31 = m13(2)/-pi; dtstar31se = mse13(2)/pi;

%Q21 = (-pi*dt21)/(p21(1))
%Q32 = (-pi*dt32)/(p32(1))
%Q31 = (-pi*dt31)/(p31(1))

% Fit
line1 = (m12(2)*freq) + m12(1);
line2 = (m23(2)*freq) + m23(1);
line3 = (m13(2)*freq) + m13(1);

% Output
tval = [dtstar21 dtstar21se dtstar32 dtstar32se dtstar31 dtstar31se];
save('tval.tst', 'tval', '-ascii');
line1out = [freq line1];
line2out = [freq line2];
line3out = [freq line3];
save('line12.lin', 'line1out', '-ascii');
save('line23.lin', 'line2out', '-ascii');
save('line13.lin', 'line3out', '-ascii');
coh12out = [freq Coh12n];
coh23out = [freq Coh23n];
coh13out = [freq Coh13n];
save('coh12.pts', 'coh12out', '-ascii');
save('coh23.pts', 'coh23out', '-ascii');
save('coh13.pts', 'coh13out', '-ascii');
rat12out = [freq ratio21n];
rat23out = [freq ratio32n];
rat13out = [freq ratio31n];
save('rat12.pts', 'rat12out', '-ascii');
save('rat23.pts', 'rat23out', '-ascii');
save('rat13.pts', 'rat13out', '-ascii');
pscs1 = [fscs1 Pscs1];
pscs2 = [fscs2 Pscs2];
pscs3 = [fscs3 Pscs3];
pnoise = [fnoise Pnoise];
save('mtm1.pts', 'pscs1', '-ascii');
save('mtm2.pts', 'pscs2', '-ascii');
save('mtm3.pts', 'pscs3', '-ascii');
save('mtmn.pts', 'pnoise', '-ascii');

% Plot
%figcol = 3; figrow = 6;
%xmin = 2/(winlen*2); xmax = 0.5*nyq;
%h = figure('PaperPosition',[0.5,0.5,7.5,10]);
%subplot(figrow,figcol,1:3); plot(t,rec); xlim([t(1) t(end)]); title(name); xlabel('Time (s)');
%subplot(figrow,figcol,4); plot(tscs1,scs1); xlim([tscs1(1) tscs1(end)]); title('ScS'); xlabel('Time (s)'); ylabel('Raw');
%subplot(figrow,figcol,5); plot(tscs2,scs2); xlim([tscs2(1) tscs2(end)]); title('ScS2'); xlabel('Time (s)');
%subplot(figrow,figcol,6); plot(tscs3,scs3); xlim([tscs3(1) tscs3(end)]); title('ScS3'); xlabel('Time (s)');
%subplot(figrow,figcol,7); loglog(fnoise,Pnoise,'--',fscs1,Pscs1); xlim([xmin xmax]); xlabel('Freq (Hz)'); ylabel('Power'); legend('noise', 'signal');
%subplot(figrow,figcol,8); loglog(fnoise,Pnoise,fscs2,Pscs2); xlim([xmin xmax]); xlabel('Freq (Hz)');
%subplot(figrow,figcol,9); loglog(fnoise,Pnoise,fscs3,Pscs3); xlim([xmin xmax]); xlabel('Freq (Hz)');
%subplot(figrow,figcol,10); plot(tscs1filt,scs1filt); xlim([tscs1filt(1) tscs1filt(end)]); xlabel('Time (s)'); ylabel('BP 15-35 mHz');
%subplot(figrow,figcol,11); plot(tscs2filt,scs2filt); xlim([tscs2filt(1) tscs2filt(end)]); xlabel('Time (s)');
%subplot(figrow,figcol,12); plot(tscs3filt,scs3filt); xlim([tscs3filt(1) tscs3filt(end)]); xlabel('Time (s)');
%subplot(figrow,figcol,13); plot(tcorr12,corr12); xlim([tcorr12(1) tcorr12(end)]); title('ScS-ScS2'); xlabel('Lag time (s)'); ylabel('X-correlate'); text(tcorr12(1),min(corr12),['\delta' 't=' num2str(diff21,2)]);
%subplot(figrow,figcol,14); plot(tcorr23,corr23); xlim([tcorr23(1) tcorr23(end)]); title('ScS2-ScS3'); xlabel('Lag time (s)'); text(tcorr23(1),min(corr23),['\delta' 't=' num2str(diff32,2)]);
%subplot(figrow,figcol,15); plot(tcorr13,corr13); xlim([tcorr13(1) tcorr13(end)]); title('ScS-ScS3'); xlabel('Lag time (s)'); text(tcorr13(1),min(corr13),['\delta' 't=' num2str(diff31,2)]);
%subplot(figrow,figcol,16); plot(freq,ratio21n,'.-',freq,line1); xlabel('Freq (Hz)'); ylabel('Log ratio'); text(f1,line1(end),['dt*=' num2str(dtstar21,2)]);
%subplot(figrow,figcol,17); plot(freq,ratio32n,'.-',freq,line2); xlabel('Freq (Hz)'); text(f1,line2(end),['dt*=' num2str(dtstar32,2)]);
%subplot(figrow,figcol,18); plot(freq,ratio31n,'.-',freq,line3); xlabel('Freq (Hz)'); text(f1,line3(end),['dt*=' num2str(dtstar31,2)]);

%print('-dpsc2','-cmyk',[name '.ps']);

%figure
%plot(freq,ratio21n,freq,ratio32n,freq,averation,'.-',freq,line); xlabel('Freq (Hz)'); text(f1,line2(end),['dt*=' num2str(dtstar,2)]);