#!/bin/csh

set dir = ~/Documents/Research/GlobalScSn/Process

set proj = -JX

set region1 = 850/2999/-1/1
set scale1 = 3.5/1.5

set region2 = 0/256/-1/1
set scale2 = 2/1.5

set region3 = 0/2/0/2
set scale3 = 0.5/1.5

set outfile = $dir/out.ps

psbasemap $proj{3.5/6} -R$region1 -Ba500f100:"Elapsed time (sec)":/S -X1 -Y1 -K >! $outfile
psxy $proj{1/1.5} -R0/1/0/1 -Sp -Gwhite -X5.5 -Y-1.5 -O -K << FIN >> $outfile
0 1
FIN

set dir = ( 1973116 1975333 1989177 2006288 )
#set dir = ( 1973116 1975333 1989177 )
set dir = Data
@ i = 1
while ( $i <= $#dir )

cd $dir[$i]


sac2xy recplot.sac recplot.xy
psxy recplot.xy $proj$scale1 -R$region1 -W1p,black -X-5.5 -Y1.5 -O -K >> $outfile

pstext $proj -R -D-0.1/0 -N -O -K << FIN >> $outfile
850 0 12 90 4 CB $dir[$i]
FIN

sac2xy scs3u.bpn.sac scs.xy
psxy scs.xy $proj$scale2 -R$region2 -W1p,red -X3.5 -Y0 -O -K >> $outfile
sac2xy scs2u.bpn.sac scs.xy
psxy scs.xy $proj$scale2 -R$region2 -W1p,green -X0 -Y0 -O -K >> $outfile
sac2xy scs1u.bpn.sac scs.xy
psxy scs.xy $proj$scale2 -R$region2 -W1p,black -X0 -Y0 -O -K >> $outfile

set dt = ` awk '{printf "%.1f\n", $1}' tval.out `
pstext $proj$scale3 -R$region3 -X2 -Y0 -O -K << FIN >> $outfile
1 1 12 0 4 CB $dt[1]
1 1 12 0 4 CT ( $dt[2] )
FIN

cd ..
@ i++
end

psbasemap $proj{2/6} -R$region2 -Ba100f50:"Relative time (sec)":/S -X-2 -Y-4.5 -O >> $outfile

gs $outfile
