#!/bin/csh

set dir = ~/Documents/Research/GlobalScSn/Process

set proj = -JX

set region1 = 0/0.1/10/1000000000
set scale1 = 1.25/1.5l

set region2 = 0.01/0.04/-2.25/-0.2
set scale2 = 1.25/1.5

set region3 = 0.01/0.04/0.5/1
set scale3 = 1.25/1.5

set region4 = 0/2/0/2
set scale4 = 1.25/0.5

set outfile = $dir/spec.ps

cd Data

psxy mtmn.pts $proj$scale1 -R$region1 -W1p,black -Ba0.04f0.02/a1:"PSD"::."1975333":neSWp -X1 -Y6.55 -K >! $outfile
psxy mtm3.pts $proj$scale1 -R$region1 -W1p,red -O -K >> $outfile
psxy mtm2.pts $proj$scale1 -R$region1 -W1p,blue -O -K >> $outfile
psxy mtm1.pts $proj$scale1 -R$region1 -W1p,green -O -K >> $outfile

psxy coh12.pts $proj$scale2 -R$region3 -Sx0.1 -W1p,grey -Ba0.01f0.005/a0.2f0.1nse -Y-1.75 -O -K >> $outfile
psxy rat12.pts $proj$scale2 -R$region2 -Sc0.1 -W1p,black -B/a0.5f0.25:"ln(ScS2/ScS)":W  -O -K >> $outfile
psxy line12.lin $proj$scale2 -R$region2 -W1p,black -O -K >> $outfile

psxy coh23.pts $proj$scale2 -R$region3 -Sx0.1 -W1p,grey -Ba0.01f0.005/a0.2f0.1nse -Y-1.5 -O -K >> $outfile
psxy rat23.pts $proj$scale2 -R$region2 -Sc0.1 -W1p,black -B/a0.5f0.25:"ln(ScS3/ScS2)":W -O -K >> $outfile
psxy line23.lin $proj$scale2 -R$region2 -W1p,black -O -K >> $outfile

psxy coh13.pts $proj$scale2 -R$region3 -Sx0.1 -W1p,grey -Ba0.01f0.005/a0.2f0.1nSe -Y-1.5 -O -K >> $outfile
psxy rat13.pts $proj$scale2 -R$region2 -Sc0.1 -W1p,black -B/a0.5f0.25:"ln(ScS3/ScS)":W -O -K >> $outfile
psxy line13.lin $proj$scale2 -R$region2 -W1p,black -O -K >> $outfile

set dt = ` awk '{printf "%.1f\n", $1}' tval.out `
pstext $proj$scale4 -R$region4 -Y-0.6 -N -O -K << FIN >> $outfile
1 0 12 0 4 CB $dt[3] ( $dt[4] )
FIN

cd ..

#set dir = ( 1989177 )
set dir = Data
@ i = 1
while ( $i <= $#dir )

cd $dir[$i]

psxy mtmn.pts $proj$scale1 -R$region1 -W1p,black -Ba0.04f0.02/a1:."$dir[$i]":neSwp -X1.25 -Y5.35 -O -K >> $outfile
psxy mtm3.pts $proj$scale1 -R$region1 -W1p,red -O -K >> $outfile
psxy mtm2.pts $proj$scale1 -R$region1 -W1p,blue -O -K >> $outfile
psxy mtm1.pts $proj$scale1 -R$region1 -W1p,green -O -K >> $outfile

psxy coh12.pts $proj$scale2 -R$region3 -Sx0.1 -W1p,grey -Ba0.01f0.005/a0.2f0.1nEs -Y-1.75 -O -K >> $outfile
psxy rat12.pts $proj$scale2 -R$region2 -Sc0.1 -W1p,black -B/a0.5f0.25w  -O -K >> $outfile
psxy line12.lin $proj$scale2 -R$region2 -W1p,black -O -K >> $outfile

psxy coh23.pts $proj$scale2 -R$region3 -Sx0.1 -W1p,grey -Ba0.01f0.005/a0.2f0.1:"Coherence":nEs -Y-1.5 -O -K >> $outfile
psxy rat23.pts $proj$scale2 -R$region2 -Sc0.1 -W1p,black -B/a0.5f0.25w -O -K >> $outfile
psxy line23.lin $proj$scale2 -R$region2 -W1p,black -O -K >> $outfile

psxy coh13.pts $proj$scale2 -R$region3 -Sx0.1 -W1p,grey -Ba0.01f0.005/a0.2f0.1nES -Y-1.5 -O -K >> $outfile
psxy rat13.pts $proj$scale2 -R$region2 -Sc0.1 -W1p,black -B/a0.5f0.25w -O -K >> $outfile
psxy line13.lin $proj$scale2 -R$region2 -W1p,black -O -K >> $outfile

set dt = ` awk '{printf "%.1f\n", $1}' tval.out `
pstext $proj$scale4 -R$region4 -Y-0.6 -N -O -K << FIN >> $outfile
1 0 12 0 4 CB $dt[3] ( $dt[4] )
FIN

cd ..
@ i++
end

psbasemap $proj{2.5/4.5} -R$region3 -Ba0.04:"Frequency (Hz)":/S -X-1.25 -Y0.6 -O >> $outfile

gs $outfile
